// datagram.cpp : implementation file
//

#include "stdafx.h"
#include "testnet.h"
#include "datagram.h"
#include "netcom.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DataGramDlg dialog

DataGramDlg* DataGramDlg::thisDlg = NULL;

DataGramDlg::DataGramDlg(CWnd* pParent /*=NULL*/)
    : CDialog(DataGramDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(DataGramDlg)
    m_PermName = "";
    m_LocalName = "";
    m_RemoteName = "";
    m_SendData = "";
    //}}AFX_DATA_INIT
    thisDlg = this;
}

void DataGramDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(DataGramDlg)
    DDX_Control(pDX, IDC_NETNAMES, m_NetNames);
    DDX_Text(pDX, IDC_PERMNAME, m_PermName);
    DDX_Text(pDX, IDC_LOCALNAME, m_LocalName);
    DDX_Text(pDX, IDC_REMOTENAME, m_RemoteName);
    DDX_Text(pDX, IDC_SENDDATA, m_SendData);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(DataGramDlg, CDialog)
    //{{AFX_MSG_MAP(DataGramDlg)
    ON_BN_CLICKED(IDOK, OnOk)
    ON_WM_DESTROY()
    ON_BN_CLICKED(IDC_INITIALIZE, OnInitialize)
    ON_BN_CLICKED(IDC_ADDGROUP, OnAddgroup)
    ON_BN_CLICKED(IDC_ADDUNIQUE, OnAddunique)
    ON_BN_CLICKED(IDC_DELETE, OnDelete)
    ON_BN_CLICKED(IDC_RECEIVEDATAGRAM, OnReceivedatagram)
    ON_BN_CLICKED(IDC_ADAPTERSTATUS, OnAdapterstatus)
    ON_BN_CLICKED(IDC_SENDDATAGRAM, OnSenddatagram)
    ON_BN_CLICKED(IDC_RESETADAPTER, OnResetadapter)
    ON_BN_CLICKED(IDC_CANCELALL, OnCancelall)
    ON_BN_CLICKED(IDC_LISTNAMES, OnListnames)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// DataGramDlg message handlers
 
BOOL DataGramDlg::OnInitDialog()
{
RECT    rect = {0};

    CDialog::OnInitDialog();
    m_NetNames.SetTabStops(72);
    
    hInstDLL = LoadLibrary("netcom.dll");
    if (hInstDLL<HINSTANCE_ERROR)
    {
        OnCancel();
    }
    else
    {                                         
            // Create the NetCom control                                                
        hWndNet = ::CreateWindow("NetCom", "", WS_CHILD, 0, 0, 0, 0, 
                    m_hWnd, (HMENU)IDC_NETCOM, AfxGetInstanceHandle(), NULL);                                               
                                    
            // Set the TRACE property to "on"
        int nRes = (int) ::SendMessage(hWndNet, NCM_SETTRACE, TRUE, 0L);
    }                                                
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void DataGramDlg::OnOk()
{
    EndDialog(0);
}

void DataGramDlg::OnDestroy()
{                              
    ::DestroyWindow(hWndNet);
    
        // Free the NetCom DLL
    if (hInstDLL>=HINSTANCE_ERROR)
        FreeLibrary(hInstDLL);
    CDialog::OnDestroy();
    thisDlg = NULL;
}

void DataGramDlg::OnInitialize()
{                               
char    szTemp[MAXNETNAME+1];

    //Initialize the NetBIOS Interface
    int nRes = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_INIT, (LPARAM) &szTemp);
    
    if (nRes)
        MessageBox("Init Failed.  NetBIOS may not be installed", "Return Value", MB_OK);
    else        
        MessageBox("Init Succeeded", "Return Value", MB_OK);
        
    //Publish the permanent adapter name
    m_PermName = szTemp;
    UpdateData(FALSE);
}

void DataGramDlg::OnAddgroup()
{                                       
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a group name in the Local Name edit control", 
            "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and register the group
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_REGISTERGROUP,
        0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Register Group Name Failed.", "Return Value", MB_OK);
    else        
        MessageBox("Register Group Name Succeeded", "Return Value", MB_OK);
}

void DataGramDlg::OnAddunique()
{
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a unique name in the Local Name edit control", 
            "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and register it
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_REGISTERNAME, 
        0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Register Name Failed.", "Return Value", MB_OK);
    else        
        MessageBox("Register Name Succeeded", "Return Value", MB_OK);   
    
}

void DataGramDlg::OnDelete()
{
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a name in the Local Name edit control"
            " to delete", "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and Delete it
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_DELETENAME, 
        0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Delete Name Failed.", "Return Value", MB_OK);
    else        
        MessageBox("Delete Name Succeeded", "Return Value", MB_OK); 
    
}

void DataGramDlg::OnReceivedatagram()
{
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a name in the Local Name edit control"
            " to listen as.", "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and Tell the control to listen for it
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, 
        NCC_RECEIVEDATAGRAM, 0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Receive setup failed", "Return Value", MB_OK);
    else        
        MessageBox("Receive setup succeeded", "Return Value", MB_OK);   
}

void DataGramDlg::OnAdapterstatus()
{     
    UpdateData();     

    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_ADAPTERSTATUS, 0L);
}

void DataGramDlg::OnSenddatagram()
{
    UpdateData();     
    
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETDATA,m_SendData.GetLength(), (LPARAM)(LPCSTR)m_SendData);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_SENDDATAGRAM, 0L);    
}

void DataGramDlg::OnResetadapter()
{
    UpdateData();     
    
    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_RESET, 0L);   
}

void DataGramDlg::OnCancelall()
{
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_CANCELALL, 0L);   
}

BOOL DataGramDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{           
    LPRECINFOSTRUCT     lpRec;
    HANDLE              hRec;       
    LPSTR               lpszTemp = NULL;
    LPSTR               lpszData = NULL;
    
    switch (LOWORD(lParam))
    {                     
        case NCN_RECEIVEDDATAGRAM:
            hRec=(HANDLE)HIWORD(lParam);
            lpRec = (LPRECINFOSTRUCT) GlobalLock(hRec);
            lpszTemp = new char[lpRec->nLen + 32];
            lpszData = new char[lpRec->nLen + 1];
            strncpy(lpszData, lpRec->lpData, lpRec->nLen);
            lpszData[lpRec->nLen] = '\0';
                       
            wsprintf(lpszTemp, "Received From %s\n%s", 
                (LPSTR) lpRec->szFrom, (LPSTR) lpszData);
            MessageBox(lpszTemp, "Received Datagram", MB_OK);
            
            delete [] lpszTemp;
            delete [] lpszData;
            GlobalUnlock(hRec);
            return TRUE;
            
        case NCN_RECEIVEDDATA:
            hRec=(HANDLE)HIWORD(lParam);
            lpRec = (LPRECINFOSTRUCT) GlobalLock(hRec);
            lpszTemp = new char[lpRec->nLen + 32];
            lpszData = new char[lpRec->nLen + 1];
            strncpy(lpszData, lpRec->lpData, lpRec->nLen);
            lpszData[lpRec->nLen] = '\0';
                       
            wsprintf(lpszTemp, "Received On Session %s\n%s", 
                (LPSTR) lpRec->szFrom, (LPSTR) lpszData);
            MessageBox(lpszTemp, "Received Data", MB_OK);
            
            delete [] lpszTemp;
            delete [] lpszData;
            GlobalUnlock(hRec);
            return TRUE;
                
    }
    
    return  CWnd::OnCommand(wParam, lParam);
}


int far pascal __export DataGramDlg::EnumProc(LPSTR lpsz, int nInt)
{
    if (thisDlg != NULL)
        return thisDlg->EnumProcHelper(lpsz, nInt);
    else
        return 0;
}

int DataGramDlg::EnumProcHelper(LPSTR lpszStr, int nNameNum)
{                                                                  
char szString[256];

    wsprintf(szString, "%s \t %d", (LPSTR) lpszStr, nNameNum);
    m_NetNames.AddString((LPCSTR)szString);
    return 1;
}
void DataGramDlg::OnListnames()
{   
    UpdateData();
    m_NetNames.ResetContent();
    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_LISTNAMES, (LPARAM) EnumProc);
    UpdateData(FALSE);
    
}
