// session.cpp : implementation file
//

#include "stdafx.h"
#include "testnet.h"
#include "session.h"
#include "netcom.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSessionDlg dialog


CSessionDlg::CSessionDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CSessionDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CSessionDlg)
    m_RemoteName = "";
    m_PermName = "";
    m_SendData = "";
	m_LocalName = "";
	//}}AFX_DATA_INIT
}

void CSessionDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSessionDlg)
    DDX_Text(pDX, IDC_REMOTENAME, m_RemoteName);
    DDX_Text(pDX, IDC_PERMNAME, m_PermName);
    DDX_Text(pDX, IDC_DATA, m_SendData);
	DDX_Text(pDX, IDC_LOCALNAME, m_LocalName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSessionDlg, CDialog)
    //{{AFX_MSG_MAP(CSessionDlg)
    ON_BN_CLICKED(IDC_INITIALIZE, OnInitialize)
    ON_BN_CLICKED(IDC_ADAPTERSTATUS, OnAdapterstatus)
    ON_BN_CLICKED(IDC_CANCELALL, OnCancelall)
    ON_BN_CLICKED(IDC_RESETADAPTER, OnResetadapter)
    ON_BN_CLICKED(IDC_ADDNAME, OnAddname)
    ON_BN_CLICKED(IDC_ADDGROUP, OnAddgroup)
    ON_BN_CLICKED(IDC_DELETE, OnDelete)
    ON_BN_CLICKED(IDC_CALL, OnCall)
    ON_BN_CLICKED(IDC_LISTEN, OnListen)
    ON_BN_CLICKED(IDC_RECEIVE, OnReceive)
    ON_BN_CLICKED(IDC_SEND, OnSend)
    ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_HANGUPSEND, OnHangupsend)
	ON_BN_CLICKED(IDC_HANGUPRECEIVE, OnHangupreceive)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSessionDlg message handlers

void CSessionDlg::OnInitialize()
{
 char    szTemp[MAXNETNAME+1];

    //Initialize the NetBIOS Interface
    int nRes = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_INIT, (LPARAM) &szTemp);
    
    if (nRes)
        MessageBox("Init Failed.  NetBIOS may not be installed", "Return Value", MB_OK);
    else        
        MessageBox("Init Succeeded", "Return Value", MB_OK);
        
    //Publish the permanent adapter name
    m_PermName = szTemp;
    UpdateData(FALSE); 
}

void CSessionDlg::OnAdapterstatus()
{
     UpdateData();     

    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_ADAPTERSTATUS, 0L);  
}

void CSessionDlg::OnCancelall()
{
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_CANCELALL, 0L);    
}

void CSessionDlg::OnResetadapter()
{
    UpdateData();     
    
    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_RESET, 0L);  
}

void CSessionDlg::OnAddname()
{
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a unique name in the Local Name edit control", 
            "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and register it
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_REGISTERNAME, 
        0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Register Name Failed.", "Return Value", MB_OK);
    else        
        MessageBox("Register Name Succeeded", "Return Value", MB_OK);   
}

void CSessionDlg::OnAddgroup()
{
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a group name in the Local Name edit control", 
            "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and register the group
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_REGISTERGROUP,
        0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Register Group Name Failed.", "Return Value", MB_OK);
    else        
        MessageBox("Register Group Name Succeeded", "Return Value", MB_OK);
}

void CSessionDlg::OnDelete()
{
    //Get the name from the control
    UpdateData();     
    if (m_LocalName.GetLength() == 0)
    {
        MessageBox("Please enter a name in the Local Name edit control"
            " to delete", "ERROR", MB_OK);
        return;
    }
          
    HCURSOR hOldCur = SetCursor(LoadCursor(NULL,IDC_WAIT));
    
    //Set the name and Delete it
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    int nRet = (int) ::SendMessage(hWndNet, NCM_SETCOMMAND, NCC_DELETENAME, 
        0L);
    
    SetCursor(hOldCur);
    
    if (nRet)
        MessageBox("Delete Name Failed.", "Return Value", MB_OK);
    else        
        MessageBox("Delete Name Succeeded", "Return Value", MB_OK);  
}

void CSessionDlg::OnCall()
{
    UpdateData();     
    
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_CALL, 0L);    
}

void CSessionDlg::OnListen()
{
   UpdateData();     
    
    ::SendMessage(hWndNet, NCM_SETNAME, m_LocalName.GetLength(), (LPARAM) (LPCSTR) m_LocalName);
    ::SendMessage(hWndNet, NCM_SETREMOTENAME,m_RemoteName.GetLength(), (LPARAM)(LPCSTR)m_RemoteName);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_LISTEN, 0L);    
}

void CSessionDlg::OnReceive()
{
    UpdateData();     
    
     ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_RECEIVE, 0L);      
}

void CSessionDlg::OnSend()
{
   UpdateData();     
    
    ::SendMessage(hWndNet, NCM_SETDATA,m_SendData.GetLength(), (LPARAM)(LPCSTR)m_SendData);
    ::SendMessage(hWndNet, NCM_SETCOMMAND,NCC_SEND, 0L);     
}

void CSessionDlg::OnCancel()
{
 
    CDialog::OnCancel();
}

BOOL CSessionDlg::OnInitDialog()
{
RECT    rect = {0};

    CDialog::OnInitDialog();
     
    hInstDLL = LoadLibrary("netcom.dll");
    if (hInstDLL<HINSTANCE_ERROR)
    {
        OnCancel();
    }
    else
    {                                         
            // Create the NetCom control                                                
        hWndNet = ::CreateWindow("NetCom", "", WS_CHILD, 0, 0, 0, 0, 
                    m_hWnd, (HMENU)IDC_NETCOM, AfxGetInstanceHandle(), NULL);                                               
                                    
            // Set the TRACE property to "on"
        int nRes = (int) ::SendMessage(hWndNet, NCM_SETTRACE, TRUE, 0L);
    }                                                
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSessionDlg::OnDestroy()
{
    ::DestroyWindow(hWndNet);
    
        // Free the NetCom DLL  
    if (hInstDLL >= HINSTANCE_ERROR)
        FreeLibrary(hInstDLL);
    CDialog::OnDestroy();
}

BOOL CSessionDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{           
    LPRECINFOSTRUCT     lpRec;
    HANDLE              hRec;       
    LPSTR               lpszTemp = NULL;
    LPSTR               lpszData = NULL;
	char				szTemp[50];
			    
    switch (LOWORD(lParam))
    {                     
		case NCN_NEWSENDSESSION:
            wsprintf(szTemp, "New Send Session: %d", 
                	 (WORD) lParam);
            MessageBox(szTemp, "NetCom", MB_OK);		
			return TRUE;
			
		case NCN_NEWRECSESSION:
            wsprintf(szTemp, "New Receive Session: %d", 
                	 (WORD) lParam);
            MessageBox(szTemp, "NetCom", MB_OK);		
			return TRUE; 
			
        case NCN_SESSIONCLOSED:

               // The hiword of lParam contains the session number
            wsprintf(szTemp,"Session %d closed",HIWORD(lParam));
            MessageBox(szTemp,"NetCom",MB_OK);
            return TRUE;

        case NCN_SENDCOMPLETE:

                        // The hiword of lParam contains the session number
            wsprintf(szTemp,"Send complete on session %d",HIWORD(lParam));
            MessageBox(szTemp,"NetCom",MB_OK);
            return TRUE; 
            
        case NCN_RECEIVEDDATA:
            hRec=(HANDLE)HIWORD(lParam);
            lpRec = (LPRECINFOSTRUCT) GlobalLock(hRec);
            lpszTemp = new char[lpRec->nLen + 60];
            lpszData = new char[lpRec->nLen + 1];
            strncpy(lpszData, lpRec->lpData, lpRec->nLen);
            lpszData[lpRec->nLen] = '\0';
                       
            wsprintf(lpszTemp, "Received On Session %s\n%s", 
                (LPSTR) lpRec->szFrom, (LPSTR) lpszData);
            MessageBox(lpszTemp, "Received Data", MB_OK);
            
            delete [] lpszTemp;
            delete [] lpszData;
            GlobalUnlock(hRec);
            return TRUE;
                
    }
    
    return  CWnd::OnCommand(wParam, lParam);
}
void CSessionDlg::OnHangupsend()
{
    	// Tell NetCom to hangup on the current SEND session
	::SendMessage(hWndNet,NCM_SETCOMMAND,NCC_HANGUPONSEND,0L);
}

void CSessionDlg::OnHangupreceive()
{
        // Tell NetCom to hangup on the current RECEIVE session
	::SendMessage(hWndNet,NCM_SETCOMMAND,NCC_HANGUPONREC,0L);
}
